# Author : Guillaume Marques
#

function separate_osi!(vic::OSIContainer, satellites::Vector{Int}, 
    customers::Vector{Int}, nb_ut_sat::Vector{Double}, y_vals::Array{Double, 3}
    )::Cvoid
  offset = satellites[1] - 1
  for s in satellites
    nb_ut_s = nb_ut_sat[s - offset]
    var_u_id = 2^(s - satellites[1])
    for c in customers
      val_edges_incident_to_c = sum(y_vals[c, :, s - offset])
      violation_value =  val_edges_incident_to_c - 2 * nb_ut_s
      if violation_value >= 10e-6
        ineq = OpenSatelliteInequality(s, c, var_u_id, violation_value)
        add_violated_inequality!(vic, ineq)
      end
    end
  end
  return
end

