# Author : Guillaume Marques
# Description : Usefull functions for SSI separation

function excludedsats(satsubsetid::Int, nbsats::Int)::Vector{Int}
    sats = Vector{Int}()
    binsatsubsetid = string(satsubsetid, base = 2)
    binsatsubsetidlen = length(binsatsubsetid)
    for (s, d) in enumerate(binsatsubsetid)
        if d == '0'
            push!(sats, binsatsubsetidlen - s + 1)
        end
    end
    if binsatsubsetidlen < nbsats
        for i in (binsatsubsetidlen+1):nbsats
            push!(sats, i)
        end
    end
    return sats
end

function wrappingsets(satsubsetid::Int, nbsats::Int)::Vector{Int}
    return [satsubsetid + 2^(sat - 1) for sat in excludedsats(satsubsetid, nbsats)]
end
