function instancefilenamebuilder(instancename::String)
    appfolder = dirname(@__FILE__)
    elems = split(instancename, "/")
    set = elems[1]
    name = elems[2]
    filename = "$appfolder/../../data/$instancename"
    if set ∈ ["Set4A" "Set4B"]
        filename = "$appfolder/../../data/$(set[1:4])/$name"
    end
    if !isfile(filename)
        err = """
        Cannot find the file $filename.
         > Path is TwoEchelonVehicleRouting/data/<arg>
        """
        error(err)
    end
    return filename
end

function file_parser(filename::String, name::String, S::Type{<: ExperimentSet})
    error("No parser implemented for experiment set $S.")
end

file_parser(f::String, n::String, ::Type{<: Set1}) = reader_2ECVRP_set1(f, n)
file_parser(f::String, n::String, ::Type{<: Set2}) = reader_2ECVRP_set2_and_set3(f, n)
file_parser(f::String, n::String, ::Type{<: Set3}) = reader_2ECVRP_set2_and_set3(f, n)
file_parser(f::String, n::String, ::Type{<: Set4A}) = reader_2ECVRP_set4(f, n, true)
file_parser(f::String, n::String, ::Type{<: Set4B}) = reader_2ECVRP_set4(f, n, false)
file_parser(f::String, n::String, ::Type{<: Set5}) = reader_2ECVRP_set5(f, n)
file_parser(f::String, n::String, ::Type{<: Set6A}) = reader_2ECVRP_set6(f, n)
file_parser(f::String, n::String, ::Type{<: Set6B}) = reader_2ECVRP_set6(f, n)
file_parser(f::String, n::String, ::Type{<: Set7}) = reader_2ECVRP_set7(f, n)

function read_instance(instancename::String)
    filename = instancefilenamebuilder(instancename)
    S = typeof(getexperimentset(instancename))
    return file_parser(filename, instancename, S)
end
