function getparameters(data::Data2EVRP, initub)::Dict{Symbol, Any}
  model_params = getmodelparameters(data)
  model_params[:init_ub] = initub
  return model_params
end

function getmodelparameters(data::Data2EVRP)::Dict{Symbol, Any}
  nb_customers = length(customers(data))
  return Dict{Symbol, Any}(
    :ng_count => min(nb_customers, 8),
    :ng_cut_count => min(nb_customers, 16),
    :buckets_number_per_vertex => 25,
    :capacity_resource_step => 1,
    :u_var_subset_size => 10,
    :tlbc_satsubset_size => 10,
    :min_time_in_restricted_master => 20
  )
end
