## Experiments sets
abstract type ExperimentSet end

struct Set1 <: ExperimentSet end
struct Set2 <: ExperimentSet end
struct Set3 <: ExperimentSet end
struct Set4A <: ExperimentSet end
struct Set4B <: ExperimentSet end
struct Set5 <: ExperimentSet end
struct Set6A <: ExperimentSet end
struct Set6B <: ExperimentSet end
struct Set7 <: ExperimentSet end

struct Formulation{S <: ExperimentSet}
  experiments_set::S
  solver
end

getsolver(f::Formulation) = f.solver

function getexperimentset(instancename::String)::ExperimentSet
  pv = split(instancename, "/")[1]
  (pv == "Set1") && return Set1()
  (pv == "Set2") && return Set2()
  (pv == "Set3") && return Set3()
  (pv == "Set4A") && return Set4A()
  (pv == "Set4B") && return Set4B()
  (pv == "Set5") && return Set5()
  (pv == "Set6A") && return Set6A()
  (pv == "Set6B") && return Set6B()
  (pv == "Set7") && return Set7()
  error("Unknown experiments set $pv.")
end

function Formulation(instancename::String, config::String, userparams::String)::Formulation
  set = getexperimentset(instancename)
  bcs = BaPCodSolver(param_file = config, print_param = false, 
    integer_objective = false, 
    user_params = userparams)
  f = Formulation(set, bcs)
  return f
end

