struct Graph2ECVRP <: GraphData
  nb_nodes_l2::Integer
  nb_nodes_l1::Integer
  offset_graph_l1::Integer
end

function digraph_1l(data::Data2EVRP{Graph2ECVRP})
  offset = data.graphdata.offset_graph_l1
  nb_nodes = data.graphdata.nb_nodes_l1
  digraph = TierGraph(offset, DiGraph(nb_nodes))
  build_graph_1l!(digraph, data)
  return digraph
end

function graph_1l(data::Data2EVRP{Graph2ECVRP})
  offset = data.graphdata.offset_graph_l1
  nb_nodes = data.graphdata.nb_nodes_l1
  graph = TierGraph(offset, Graph(nb_nodes))
  build_graph_1l!(graph, data)
  return graph
end

function digraph_2l(data::Data2EVRP{Graph2ECVRP})
  nb_nodes = data.graphdata.nb_nodes_l2
  digraph = TierGraph(0, DiGraph(nb_nodes))
  build_graph_2l!(digraph, data)
  return digraph
end

function graph_2l(data::Data2EVRP{Graph2ECVRP}, s)
  nb_nodes = data.graphdata.nb_nodes_l2
  graph = TierGraph(0, Graph(nb_nodes))
  build_graph_2l!(graph, data, s)
  return graph
end

function build_graph_1l!(graph::TierGraph, data::Data2EVRP{Graph2ECVRP})
  D = cdc(data)
  S = satellites(data)
  complete_bipartite_edges!(graph, D, S)
  complete_edges!(graph, S)
  complete_bipartite_edges!(graph, S, D)
end

function build_graph_2l!(graph::TierGraph, data::Data2EVRP{Graph2ECVRP}, s)
  G = depots(data)
  S = satellites(data)
  C = customers(data)
  if length(G) > 0
    complete_bipartite_edges!(graph, G, S)
    complete_bipartite_edges!(graph, C, G)
  else
    complete_bipartite_edges!(graph, C, s)
  end
  complete_bipartite_edges!(graph, s, C)
  complete_edges!(graph, C)
end
